#include "compat.h"
#include "libconfig.h"

int help_cmd(const char *arg, const char *argarg, const char *val, lc_flags_t flags, void *extra) {
	printf("Usage info goes here\n");
	printf("\n");

	exit(EXIT_FAILURE);
}
int sally_cmd(const char *arg, const char *argarg, const char *val, lc_flags_t flags, void *extra) {
	PRINTERR_D("%s sets value: \"%s\" (flags=%i)", arg, val, flags);
	return(0);
}

int cmd_ifmodule(const char *arg, const char *argarg, const char *val, lc_flags_t flags, void *extra) {
	SPOTVAR_S(arg);

	if (argarg != NULL) {
		SPOTVAR_S(argarg);
	}
	if (flags == LC_FLAGS_SECTIONSTART) {
		CHECKPOINT;
	}
	return(LC_CBRET_IGNORESECTION);
}

int main(int argc, char **argv) {
	char *joeval = NULL;
	long long xval = -1;
	int onoff = -1;
	int lcpret = -1;
	lc_err_t errs;

	lc_register_var("Section", LC_VAR_SECTION, NULL, 0);
	lc_register_var("Somesection", LC_VAR_SECTION, NULL, 0);
	lc_register_var("Section.Test", LC_VAR_STRING, &joeval, 'j');
	lc_register_var("bob", LC_VAR_SIZE_LONG_LONG, &xval, 's');
	lc_register_var("Somesection.Free", LC_VAR_BOOL, &onoff, 0);
	lc_register_callback("sally", sally_cmd, 0, NULL);
	lc_register_callback("HELP", help_cmd, ':', NULL);
	lc_register_callback("HELP", help_cmd, '?', NULL);
	lc_register_callback("*.ifmodule", cmd_ifmodule, 0, NULL);
	lcpret = lc_process(argc, argv, "testapp", LC_CONF_APACHE, "test.cfg");
	if (lcpret < 0) {
		PRINTERR("Error processing config file: %s", lc_geterrstr());
//		return(EXIT_FAILURE);
	}

	if (joeval != NULL) {
		SPOTVAR_S(joeval);
	}
	SPOTVAR_LLU(xval);
	SPOTVAR_I(onoff);

	return(0);
}
